//package utils;

import javax.net.ssl.*;
import java.security.*;

public class Utils{

 /*********************************************************************************** 
 Mtodo getKeyStore(): retorna um keystore
  - o KeyStore  o local onde as chaves e os certificados so mantidos
  - String tipo: especifica o provedor do gerenciador de chaves.
 ***********************************************************************************/
 protected static KeyStore getKeyStore(String tipo) throws KeyStoreException{
 
   //utiliza a implementao do keystore provido pela Sun
   return KeyStore.getInstance(tipo);
  
 } 
 
 /***********************************************************************************
 Mtodo getKMFactory(): retorna um KeyManagerFactory
  - KeyManagerFactory  usado para criar gerenciadores de chaves
  - String algoritmo: especifica o algortimo para a criao do KeyManagerFactory
 ***********************************************************************************/
 protected static KeyManagerFactory getKMFactory(String algoritmo) throws NoSuchAlgorithmException{
 
  //cria um caminho de certificao baseado em X509
  return KeyManagerFactory.getInstance(algoritmo);
 
 }
 
 /***********************************************************************************
 Mtodo criaSSLContext(): cria um objeto SSLContext
  - Um SSLContext  um ambiente para implementar JSSE
  -  utilizado para criar um ServerSocketFactory
  - String protocolo: especifica o protocolo a ser utilizado
 ***********************************************************************************/
 protected static SSLContext criaSSLContext(String protocolo) throws NoSuchAlgorithmException{
 
  return SSLContext.getInstance(protocolo);
  
 }

}